define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for FichaOrden_clone_1 generated by Appery.io
         * @module FichaOrden_clone_1
         */
        APP.controller('FichaOrden_clone_1', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.orden = Apperyio.EntityAPI('Orden');
            $scope.photos = Apperyio.EntityAPI('Photos');
            $scope.marker = Apperyio.EntityAPI('String');
            $scope.nuevoRepuesto = Apperyio.EntityAPI('String');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.showLoading();
                var orderId = Apperyio.get('userManager').orderId;
                $scope.estadoOp = JSON.parse(localStorage.getItem("diasOperacion"));
                $scope.minFechaSelect = formatDateNow2($scope.diasSeleccionCalendarioRetro);
                $scope.mOperators = localStorage.getItem("arrayOperators") ? JSON.parse(localStorage.getItem("arrayOperators")) : [];
                // Atributos para el mapa
                $scope.map = {
                    control: {},
                    zoom: 13,
                    center: {
                        latitude: '-33.4513',
                        longitude: '-70.6484'
                    }
                };
                var requestData = {};
                requestData = (function mapping6253($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params._id = orderId;
                    return requestData;
                    /*|button_mapping|onbeforesend|0AB05E5A-F52D-51F0-9765-46588C300455||6253|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_read_service")(requestData).then( /*|service_bookmark|bookmark|0AB05E5A-F52D-51F0-9765-46588C300455||5344|*/
                    function(success) { // success callback
                        (function mapping6854(success, $scope) {
                            var orden_scope = $scope.orden;
                            _.set(orden_scope, 'marca', success.data.productAntecedent ? success.data.productAntecedent.marca : "");
                            _.set(orden_scope, 'codigo', success.data.documentCode);
                            _.set(orden_scope, 'cliente', success.data.receiverAntecedent ? success.data.receiverAntecedent.nombreCliente : "");
                            _.set(orden_scope, 'fechaSolicitud', success.data.requestDate);
                            _.set(orden_scope, 'comuna', success.data.receiverAntecedent ? success.data.receiverAntecedent.comuna : "");
                            _.set(orden_scope, 'ingeniero', success.data.operatorCode);
                            _.set(orden_scope, 'tipoServicio', success.data.formType);
                            _.set(orden_scope, 'subTipoServicio', success.data.formSubType);
                            _.set(orden_scope, 'fechaCompra', success.data.productAntecedent ? success.data.productAntecedent.fechaCompra : null);
                            _.set(orden_scope, 'nomEstado', $scope.stateList[success.data.documentStatus].estado);
                            _.set(orden_scope, 'color', $scope.stateList[success.data.documentStatus].color);
                            _.set(orden_scope, 'fechaEjecucion', success.data.endDate);
                            //        _.set(orden_scope, 'fechaEstimada', success.data.fechaEstimada);
                            _.set(orden_scope, 'fechaAsignacionData', formatDate21(success.data.assignmentDate));
                            _.set(orden_scope, 'mensajeCliente', success.data.receiverAntecedent ? success.data.receiverAntecedent.mensajeCliente : "");
                            _.set(orden_scope, 'direccion', success.data.receiverAntecedent ? success.data.receiverAntecedent.direccion : "");
                            var tel = "";
                            var coma = "";
                            if (success.data.receiverContact) {
                                for (var p in success.data.receiverContact.phone) {
                                    if (success.data.receiverContact.phone.hasOwnProperty(p)) {
                                        tel += coma + p + ": " + success.data.receiverContact.phone[p];
                                        coma = ", ";
                                    }
                                }
                            }
                            _.set(orden_scope, 'telefonoCliente', tel);
                            //        _.set(orden_scope, 'correoCliente', success.data.receiverContact.email);
                            //_.set(orden_scope, 'diagEspecialistaTexto', success.data.operationData.form[2].sectionData.fieldSections[0].fields[0].value);
                            //_.set(orden_scope, 'trabEspecialistaTexto', success.data.operationData.form[3].sectionData.fieldSections[0].fields[0].value);
                            _.set(orden_scope, 'articulo', success.data.productAntecedent ? success.data.productAntecedent.articulo : "");
                            _.set(orden_scope, 'fechaInicioServicio', success.data.initDate);
                            //        _.set(orden_scope, 'checkList', success.data.operationData.form[1].sectionData.fieldSections[0].fields);
                            //        _.set(orden_scope, 'repuestos', success.data.operationData.form[0].sectionData.fieldSections[0].fields);
                            _.set(orden_scope, 'descripcionDefecto', success.data.previousDiagnosis ? success.data.previousDiagnosis.descripcionDefecto : "");
                            _.set(orden_scope, 'descripcionReparacion', success.data.previousDiagnosis ? success.data.previousDiagnosis.descripcionReparacion : "");
                            _.set(orden_scope, 'investigacion', success.data.previousDiagnosis ? success.data.previousDiagnosis.investigacion : "");
                            var arrFotos = [];
                            for (var i in success.data.operationData.form[4].sectionData.fieldSections[0].fields) {
                                if (success.data.operationData.form[4].sectionData.fieldSections[0].fields[i].value) {
                                    arrFotos.push(success.data.operationData.form[4].sectionData.fieldSections[0].fields[i]);
                                }
                            }
                            _.set(orden_scope, 'fotos', arrFotos);
                            _.set(orden_scope, '_id', success.data._id);
                            _.set(orden_scope, 'colorExistePosGPS', success.data.assignmentLocation ? "default" : "danger");
                            _.set(orden_scope, 'existePosGPS', success.data.assignmentLocation ? true : false);
                            _.set(orden_scope, 'msgNoPosGPS', success.data.assignmentLocation ? "" : " (POSICION GPS NO DETERMINADA)");
                            if (success.data.assignmentLocation) {
                                $scope.markers = [success.data.assignmentLocation];
                                $scope.map.center = {
                                    latitude: $scope.markers[0].latitude,
                                    longitude: $scope.markers[0].longitude
                                };
                            }
                            $scope.ordenNoEditable = !$scope.stateList[success.data.documentStatus].estadoInicial;
                            $scope.selectEstadoElem = success.data.documentStatus.toString();
                            $scope.selectOperatorElem = success.data.operatorCode.toString();
                            $scope.orden = orden_scope;
                            /*|button_mapping|onsuccess|0AB05E5A-F52D-51F0-9765-46588C300455||6854|*/
                        })(success, $scope);
                        for (var i in $scope.orden.repuestos) {
                            $scope.orden.repuestos[i].repAdicional = $scope.orden.repuestos[i].type == "a" ? "ADICIONAL" : "";
                        }
                        $scope.stopLoading();
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al cargar la ficha: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function getPhotos
             * @param idOrden
             */
            $scope.getPhotos = function(idOrden) {
                var requestData = {};
                requestData = (function mapping6664($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        idOrden: idOrden
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|1E07EA94-207F-4F0D-1592-08AA3B8D8B8A||6664|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_PICTURES_query_service")(requestData).then( /*|service_bookmark|bookmark|1E07EA94-207F-4F0D-1592-08AA3B8D8B8A||1331|*/
                    function(success) { // success callback
                        (function mapping4162(success, $scope) {
                            var photos_scope = $scope.photos;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(photos_scope, '[' + i + '].imagen', success.data[i].imagen);
                            }
                            $scope.photos = photos_scope;
                            /*|button_mapping|onsuccess|1E07EA94-207F-4F0D-1592-08AA3B8D8B8A||4162|*/
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function test
             */
            $scope.test = function() {
                alert(1);
            };
            /**
             * @function agregarRepuesto
             */
            $scope.agregarRepuesto = function() {
                if ($scope.nuevoRepuesto) {
                    //Chequear si el repuesto ya existe en el arreglo de datos
                    for (var i in $scope.orden.repuestos) {
                        elem = $scope.orden.repuestos[i];
                        if (elem.codigo == $scope.nuevoRepuesto) {
                            //            $scope.addRepuesto($scope.nuevoRepuesto);
                            $('#inputBuscarRepuesto').select();
                            $('#inputBuscarRepuesto').focus();
                            return;
                        }
                    }
                    var respuestoEncontrado = false;
                    //Buscar el repuesto en el arreglo DE REPUESTOS VÁLIDOS
                    $scope.nuevoRepuesto
                    for (var i in $scope.listaRepuestos) {
                        elem = $scope.listaRepuestos[i];
                        if (elem.codigo == $scope.nuevoRepuesto) {
                            elem.estado = false;
                            $scope.orden.repuestos.push(elem);
                            respuestoEncontrado = true;
                            $scope.nuevoRepuesto = "";
                            break;
                        }
                    }
                    if (!respuestoEncontrado) {
                        alert("Código de repuesto \"" + $scope.nuevoRepuesto + "\" no encontrado");
                    }
                    $('#inputBuscarRepuesto').select();
                    $('#inputBuscarRepuesto').focus();
                }
            };
            /**
             * @function eliminarRepuesto
             * @param codigo
             */
            $scope.eliminarRepuesto = function(codigo) {
                var listaRepuestosTemp = [];
                for (var i in $scope.orden.repuestos) {
                    elem = $scope.orden.repuestos[i];
                    if (elem.codigo != codigo) {
                        listaRepuestosTemp.push($scope.orden.repuestos[i]);
                    }
                }
                $scope.orden.repuestos = listaRepuestosTemp;
                $('#inputBuscarRepuesto').select();
                $('#inputBuscarRepuesto').focus();
            };
            /**
             * @function addRepuesto
             * @param codigo
             */
            $scope.addRepuesto = function(codigo) {
                for (var i in $scope.orden.repuestos) {
                    elem = $scope.orden.repuestos[i];
                    if (elem.codigo == codigo) {
                        elem.cantidad++;
                        break;
                    }
                }
            };
            /**
             * @function substractRepuesto
             * @param codigo
             */
            $scope.substractRepuesto = function(codigo) {
                for (var i in $scope.orden.repuestos) {
                    elem = $scope.orden.repuestos[i];
                    if (elem.codigo == codigo) {
                        elem.cantidad--;
                        if (elem.cantidad <= 0) {
                            $scope.eliminarRepuesto(codigo);
                        }
                        break;
                    }
                }
            };
            /**
             * @function updateOrder
             */
            $scope.updateOrder = function() {
                $scope.showLoading("Actualizando Datos...");
                //Validar la fecha de asignación
                var requestData = {};
                requestData = (function mapping1489($scope) {
                    var requestData = {};
                    requestData.data = {};
                    requestData.params = {};
                    var orden_scope = $scope.orden;
                    //        _.set(requestData.data, 'repuestos', JSON.stringify(orden_scope.repuestos));
                    //        _.set(requestData.data, 'estado', orden_scope.estado);
                    _.set(requestData.data, 'operatorCode', orden_scope.ingeniero);
                    if (orden_scope.fechaAsignacionModel)
                        _.set(requestData.data, 'assignmentDate', formatDate3(orden_scope.fechaAsignacionModel.toISOString()));
                    requestData.params._id = orden_scope._id;
                    return requestData;
                    /*|button_mapping|onbeforesend|21359D9E-04E6-4BB9-4E34-FB209F738C94||1489|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_update_service")(requestData).then( /*|service_bookmark|bookmark|21359D9E-04E6-4BB9-4E34-FB209F738C94||8158|*/
                    function(success) { // success callback
                        /*|button_mapping|onsuccess|21359D9E-04E6-4BB9-4E34-FB209F738C94||6391|*/
                        $scope.stopLoading();
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al actualizar la orden: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function openModalPhoto
             * @param src
             */
            $scope.openModalPhoto = function(src) {
                localStorage.setItem("srcModal", src);
                Apperyio.get('Modals').loadModal("showImageFull").then(
                    function(modal) {
                        modal.scope.current_item = {
                            // Set input object for send to modal window
                            // Value: .itemFromModal
                        };
                        modal.scope.modalInstance = modal.open({
                            // Optional settings:
                            size: 'lg',
                            /* 'lg' | 'sm' */
                            backdrop: true,
                            /* true | false | 'static' */
                            keyboard: true,
                            /* true | false */
                            backdropClass: '',
                            /* backdropClass name */
                            windowClass: '',
                            /* additional CSS class(es) to be added to a modal window template */
                            windowTemplateUrl: '' /* a path to a template overriding modal's window template */
                        });
                        modal.scope.modalInstance.result.then(
                            function(current_item) {
                                // Custom implementation with modal response with current_item
                            },
                            function(error) {
                                console.log(error);
                            }
                        );
                    });
            };
            /**
             * @function formatDate2
             * @param fecha
             */
            function formatDate2(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(" ");
                var f = arrFecha[0].split("-");
                return f[2] + "-" + f[1] + "-" + f[0];
            };
            /**
             * @function formatDate21
             * @param fecha
             */
            function formatDate21(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(" ");
                return arrFecha[0];
            };
            /**
             * @function formatDate3
             * @param date
             */
            function formatDate3(date) {
                var fecha = date.split("T");
                return fecha[0];
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + $scope.addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function existeFechaProceso
             * @param arregloDias
             * @param fecha
             */
            function existeFechaProceso(arregloDias, fecha) {
                for (var i in arregloDias)
                    if (arregloDias[i].fecha == fecha)
                        return true;
                return false;
            };
            /**
             * @function validarFechaOperacion
             */
            $scope.validarFechaOperacion = function() {
                if (existeFechaProceso($scope.estadoOp, formatDate3($scope.orden.fechaAsignacionModel.toISOString()))) {
                    $scope.mAlert("La fecha a la que está intentando mover la orden ya está procesada. Selecciones una fecha distinta");
                    $scope.orden.fechaAsignacionModel = formData44($scope.orden.fechaAsignacionData);
                }
            };
            /**
             * @function formData44
             * @param fecha
             */
            function formData44(fecha) {
                if (!fecha)
                    return fecha;
                var a1Arr = fecha.split("-");
                return new Date(a1Arr[0], a1Arr[1] - 1, a1Arr[2]);
            };
        }
    });